;;;
;;; mymac.el
;;;
;;; By Ross Ridge
;;; Public Domain
;;;

(defconst mymac-release "mymac 1.0")
(defconst mymac-ident "@(#) mymac mymac.el 2.2 95/04/09 02:54:43")

(or noninteractive
  (setq debug-on-error t))

(defconst mymac-macro-list nil) ; Set below

;;(if (not (fboundp 'mymac-load-default-macros))
;;    (let ((load-path (append (list nil) load-path)))
;;      (load "mymac-fn")))

(require 'mymac-fn)

(or mymac-macro-list
    (if (not (fboundp 'eval-when-compile))
	(setq mymac-macro-list (mymac-load-default-macros))
      (progn
	(defun mymac-xlist-to-list (in)
	  (let ((sym) (fn) (fsym))
	    (mapcar (function (lambda (list)
				(setq sym (make-symbol (car list)))
				(set sym (car (cdr list)))
				(setq fn (cdr (cdr list)))
				(if (cdr fn)
				    (progn 
				      (setq fsym (make-symbol (car fn)))
				      (fset fsym (car (cdr fn)))
				      (fset sym fsym))
				  (fset sym (car fn)))
				sym))
		    in)))
	(setq mymac-macro-list
	      (mymac-xlist-to-list
	       (eval-when-compile
		 (let ((fsym))
;;		   (if (not (fboundp 'mymac-load-default-macros))
;;		       (let ((load-path (append (list nil) load-path)))
;;			 (load "mymac-fn.el")))
		   (require 'mymac-fn "mymac-fn.el")
		   (mapcar '(lambda (sym)
			      (setq fsym (symbol-function sym))
			      (if (and
				   (symbolp fsym)
				   (not	(eq (intern-soft (symbol-name fsym)) 
					    fsym)))
				  (list (symbol-name sym) (symbol-value sym) 
					(symbol-name fsym)
					(symbol-function fsym))
				(list (symbol-name sym) (symbol-value sym)
				      fsym)))
			   (mymac-load-default-macros))))))
	(fmakunbound 'mymac-xlist-to-list))))

(provide 'mymac)
